## wxObject

This is the root class of all wxWidgets classes. It declares a virtual destructor which ensures that destructors get called for all derived class objects where necessary.

wxObject is the hub of a dynamic object creation scheme, enabling a program to create instances of a class only knowing its string class name, and to query the class hierarchy.

The class contains optional debugging versions of new and delete, which can help trace memory allocation and deallocation problems.

wxObject can be used to implement reference counted objects, such as wxPen, wxBitmap and others.

See also

wxClassInfo, Debugging overview, wxObjectRefData

Members

wxObject::wxObject
wxObject::~wxObject
wxObject::m_refData
wxObject::Dump
wxObject::GetClassInfo
wxObject::GetRefData
wxObject::IsKindOf
wxObject::Ref
wxObject::SetRefData
wxObject::UnRef
wxObject::operator new
wxObject::operator delete

### wxObject::wxObject

wxObject()

wxObject(const wxObject& other)

Default and copy constructors.

### wxObject::~wxObject

wxObject()

Destructor. Performs dereferencing, for those objects that use reference counting.

### wxObject::m_refData

wxObjectRefData* m_refData

Pointer to an object which is the object's reference-counted data.

See also

wxObject::Ref, wxObject::UnRef, wxObject::SetRefData, wxObject::GetRefData, wxObjectRefData

### wxObject::Dump

void Dump(ostream& stream)

A virtual function that may be redefined by derived classes to allow dumping of memory states.

This function is only defined in debug build and doesn't exist at all if `__WXDEBUG__` is not defined.

Parameters

stream

Stream on which to output dump information.

Remarks

Currently wxWidgets does not define Dump for derived classes, but programmers may wish to use it for their own applications. Be sure to call the Dump member of the class's base class to allow all information to be dumped.

The implementation of this function in wxObject just writes the class name of the object.

### wxObject::GetClassInfo

wxClassInfo * GetClassInfo()

This virtual function is redefined for every class that requires run-time type information, when using DECLARE_CLASS macros.

### wxObject::GetRefData

wxObjectRefData* GetRefData() const

Returns the m_refData pointer.

See also

wxObject::Ref, wxObject::UnRef, wxObject::m_refData, wxObject::SetRefData, wxObjectRefData

### wxObject::IsKindOf

bool IsKindOf(wxClassInfo *info)

Determines whether this class is a subclass of (or the same class as) the given class.

Parameters

info

A pointer to a class information object, which may be obtained by using the CLASSINFO macro.

Return value

true if the class represented by info is the same class as this one or is derived from it.

Example

      bool tmp = obj->IsKindOf(CLASSINFO(wxFrame));

### wxObject::Ref

void Ref(const wxObject& clone)

Makes this object refer to the data in clone.

Parameters

clone

The object to 'clone'.

Remarks

First this function calls wxObject::UnRef on itself to decrement (and perhaps free) the data it is currently referring to.

It then sets its own m_refData to point to that of clone, and increments the reference count inside the data.

See also

wxObject::UnRef, wxObject::m_refData, wxObject::SetRefData, wxObject::GetRefData, wxObjectRefData

### wxObject::SetRefData

void SetRefData(wxObjectRefData* data)

Sets the m_refData pointer.

See also

wxObject::Ref, wxObject::UnRef, wxObject::m_refData, wxObject::GetRefData, wxObjectRefData

### wxObject::UnRef

void UnRef()

Decrements the reference count in the associated data, and if it is zero, deletes the data. The m_refData member is set to NULL.

See also

wxObject::Ref, wxObject::m_refData, wxObject::SetRefData, wxObject::GetRefData, wxObjectRefData

### wxObject::operator new

void * new(size_t size, const wxString& filename = NULL, int lineNum = 0)

The new operator is defined for debugging versions of the library only, when the identifier __WXDEBUG__ is defined. It takes over memory allocation, allowing wxDebugContext operations.

### wxObject::operator delete

void delete(void buf)

The delete operator is defined for debugging versions of the library only, when the identifier __WXDEBUG__ is defined. It takes over memory deallocation, allowing wxDebugContext operations.